Global Max.l
Global idx.l
Global Zoom.l

Procedure Showimage()
  SetGadgetText(6,Str(idx+1)+"/"+Str(max))
  img=Print_GetPreviewImage(idx)
  If img
    SetGadgetState(1,ImageID(img))
  EndIf
EndProcedure

Procedure Print_Preview(Preview)
  ;Print_SetDebug(#True)
  
  Print_OpenPrinter("","PAPERSIZE="+Str(#DMPAPER_A4)+",ORIENTATION="+Str(#DMORIENT_PORTRAIT))
  
  If Preview=#True
    pw=(450*Zoom)/100
    Print_StartPreview(pw)
    xa=Print_GetDeviceCaps(#HORZRES)+20
    ya=Print_GetDeviceCaps(#VERTRES)+20
    SetGadgetAttribute(0,#PB_ScrollArea_InnerWidth,xa)
    SetGadgetAttribute(0,#PB_ScrollArea_InnerHeight,ya)
  Else
    Print_StartPrinting("TEST")
  EndIf
  
  ; Start preview
  Print_Font("Arial",28,#PB_Font_Bold)
  text$="PrinterLib Barcode Test Page"
  len=Print_TextWidth(text$)
  Print_Text(210/2-len/2,5,text$)
  
  h1.f=14
  w1.f=0.1905
  w2.f=0.3175
  w3.f=0.4445
  w4.f=0.5715
  w5.f=0.6985
  edgebar.f=1.5
  xoffset.f=0
  yoffset.f=0.6

  x.f=50:y.f=20:y1.f=20

  Print_Font("Arial",6)
  
  Print_Barcode_EAN8(x,y,"5512345",h1,w3,#PRINT_TEXT_BOTTOM,yoffset,edgebar,#True)
  Print_Text(x-40,y+10,"EAN8"):x+x1:y+y1
  
  Print_Barcode_EAN13(x,y,"123456789012",h1,w3,#PRINT_TEXT_BOTTOM,yoffset,edgebar,#True)
  Print_Text(x-40,y+10,"EAN13"):x+x1:y+y1
  
  Print_Barcode_UPC_A(x,y,"34109876534" ,h1,w3,#PRINT_TEXT_BOTTOM,yoffset,edgebar,#True)
  Print_Text(x-40,y+10,"UPC-A"):x+x1:y+y1
  
  Print_Barcode_UPC_E(x,y,"123456",h1,w3,#PRINT_TEXT_BOTTOM,yoffset,edgebar,0) ; Number system=0
  Print_Text(x-40,y+10,"UPC-E"):x+x1:y+y1
  
  ;Print_Barcode_Code128(x,y,"TEST",h1,w3,#PRINT_TEXT_BOTTOM,xoffset,yoffset,#PRINT_BARCODE_CODE128_CODEA)
  ;Print_Text(x-40,y+10,"Code 128 A"):x+x1:y+y1
  
  ;Print_Barcode_Code128(x,y,"test",h1,w3,#PRINT_TEXT_BOTTOM|#PRINT_TEXT_CENTER,xoffset,yoffset,#PRINT_BARCODE_CODE128_CODEB)
  ;Print_Text(x-40,y+10,"Code 128 B"):x+x1:y+y1
  
  ;Print_Barcode_Code128(x,y,"08154711",h1,w3,#PRINT_TEXT_BOTTOM|#PRINT_TEXT_RIGHT,xoffset,yoffset,#PRINT_BARCODE_CODE128_CODEC)
  ;Print_Text(x-40,y+10,"Code 128 C"):x+x1:y+y1
  
  Print_Barcode_Code128(x,y,"EP12345678A1234",h1,w3,#PRINT_TEXT_BOTTOM|#PRINT_TEXT_RIGHT,xoffset,yoffset,#PRINT_BARCODE_CODE128_AUTO)
  Print_Text(x-40,y+10,"Code 128 Auto"):x+x1:y+y1
  
  ;Print_Barcode_Code128(x,y,"TEST"+Chr(13)+"12345678",h1,w3,0,xoffset,yoffset,#PRINT_BARCODE_CODE128_AUTOA)
  ;Print_Text(x-40,y+10,"Code 128 AutoA"):x+x1:y+y1
  
  Print_Barcode_Code39(x,y,"TEST39",h1,w3,#PRINT_TEXT_BOTTOM,xoffset,yoffset,#True)
  Print_Text(x-40,y+10,"Code 39"):x+x1:y+y1
  
  ;Print_Barcode_Code39Full(x,y,"test39Full",h1,w3,#PRINT_TEXT_BOTTOM,xoffset,yoffset,#True)
  ;Print_Text(x-40,y+10,"Code 39 Full"):x+x1:y+y1
  
  Print_Barcode_Code93(x,y,"TEST93",h1,w3,#PRINT_TEXT_BOTTOM,xoffset,yoffset)
  Print_Text(x-40,y+10,"Code 93"):x+x1:y+y1
  
  ;Print_Barcode_Code93(x,y,"!"+Chr(34)+"$%&/()=",h1,w3,#PRINT_TEXT_BOTTOM|#PRINT_TEXT_CENTER,xoffset,yoffset)
  ;Print_Text(x-40,y+10,"Code93"):x+x1:y+y1
  
  Print_Barcode_Code2of5std(x,y,"1234567",h1,w3,#PRINT_TEXT_BOTTOM,xoffset,yoffset,#True)
  Print_Text(x-40,y+10,"Code 2 of 5 standard"):x+x1:y+y1
  
  Print_Barcode_Code2of5(x,y,"12345670",h1,w3,#PRINT_TEXT_BOTTOM,xoffset,yoffset,#True)
  Print_Text(x-40,y+10,"Code 2 of 5 interleaved"):x+x1:y+y1
  
  Print_Barcode_2Digit_Supp(x,y,"12",h1,w3,#PRINT_TEXT_BOTTOM,xoffset,yoffset)
  Print_Text(x-40,y+10,"2 Digit-Supplement"):x+x1:y+y1
  
  Print_Barcode_5Digit_Supp(x,y,"99999",h1,w3,#PRINT_TEXT_BOTTOM,xoffset,yoffset)
  Print_Text(x-40,y+10,"5 Digit-Supplement"):x+x1:y+y1
  
  ; ISBN test
  Print_Barcode_EAN13(x,y,"978389011528",h1,w3,#PRINT_TEXT_BOTTOM,yoffset,edgebar,#True)
  Print_Barcode_5Digit_Supp(x+45,y+edgebar,"02980",h1,w3,#PRINT_TEXT_TOP|#PRINT_TEXT_RIGHT,xoffset,yoffset)
  Print_Text(x-40,y+10,"EAN13 + 5 Digit-Supplement"):x+x1:y+y1
  
  Print_Barcode_Codabar(x,y,"A12345D",h1,w3,#PRINT_TEXT_BOTTOM,xoffset,yoffset)
  Print_Text(x-40,y+10,"Codabar"):x+x1:y+y1    
  
  ; Preview end
  If Preview=#True
    Print_StopPreview()
  Else
    Print_StopPrinting()
  EndIf
  max=Print_GetPreviewCount()
  Showimage()
EndProcedure

Procedure Button_First()
  idx=0
  Showimage()
EndProcedure

Procedure Button_Left()
  If idx>0
    idx-1
  EndIf
  Showimage()
EndProcedure

Procedure Button_Right()
  If idx<(max-1)
    idx+1
  EndIf
  Showimage()
EndProcedure

Procedure Button_Last()
  If max>0
    idx=max-1
  Else
    idx=max
  EndIf
  Showimage()
EndProcedure

Procedure Button_Zoom()
  Select Zoom
    Case 100
      Zoom=150
    Case 150
      Zoom=200
    Case 200
      Zoom=300
    Case 300
      Zoom=400
    Case 400
      Zoom=500
    Case 500
      Zoom=800
    Case 800
      Zoom=100
  EndSelect
  
  Print_Preview(#True)
  
  SetGadgetText(8,"Zoom "+Str(Zoom)+"%")
EndProcedure

If OpenWindow(0,0,0,500,720,"Test",#PB_Window_SystemMenu)
  If CreateGadgetList(WindowID(0))
    ScrollAreaGadget(0,10,10,480,680, 470, 670, 30)
      ImageGadget(1,10,10,480,680,0)
    CloseGadgetList()
  EndIf
  ButtonGadget(2,10,695,20,20,"|<")
  ButtonGadget(3,30,695,20,20,"<")
  ButtonGadget(4,50,695,20,20,">")
  ButtonGadget(5,70,695,20,20,">|")
  TextGadget(6,100,695,40,20,"0/0",#PB_Text_Border)
  ButtonGadget(7,150,695,40,20,"Print")
  ButtonGadget(8,200,695,70,20,"Zoom 100%")
EndIf

idx=0
Zoom=100
Print_Preview(#True)

Repeat
  event=WaitWindowEvent()
  Select event
    Case #PB_Event_Gadget
      If EventType()=#PB_EventType_LeftClick
        Select EventGadget()
          Case 2
            Button_First()
          Case 3
            Button_Left()
          Case 4
            Button_Right()
          Case 5
            Button_Last()
          Case 7
            Print_Preview(#False)
          Case 8
            Button_Zoom()
        EndSelect
      EndIf
  EndSelect
Until event=#PB_Event_CloseWindow
; IDE Options = PureBasic 4.20 (Windows - x86)
; CursorPosition = 14
; Folding = --
; Executable = ..\Printer_Lib\Source\test 1.exe